<?php

new chimppress_setup;

class chimppress_setup {

	function chimppress_setup(){
		$this->__construct();
	} // function

	function __construct(){
	
		new chimppress_meta_boxes; //set up meta boxes for custom post type page
		
		//add actions
		add_action( 'init', array( &$this, 'chimppress_register' ) );
		add_action('admin_menu',array(&$this,'add_menus'));
		add_action( 'manage_posts_custom_column', array( &$this, 'chimppress_columns' ) );
		add_action('admin_print_scripts', array( &$this, 'chimppress_enqueue_scripts' ) );
		add_action("admin_print_styles", array( &$this, 'chimppress_enqueue_styles' ));		
		//add filters
		add_filter('manage_edit-chimppress_columns', array( &$this, 'chimppress_columns_content' ) );
				
	} // function
	
	function chimppress_register() {
	 
		$labels = array(
			'name' => _x('ChimpPress', 'post type general name'),
			'singular_name' => _x('Campaign', 'post type singular name'),
			'add_new' => _x('Add New Campaign', 'Campaign'),
			'add_new_item' => __('Add New Campaign'),
			'edit_item' => __('Edit Campaign'),
			'new_item' => __('New Campaign'),
			'view_item' => __('View online version'),
			'search_items' => __('Search Campaigns'),
			'not_found' =>  __('Nothing found'),
			'not_found_in_trash' => __('Nothing found in Trash'),
			'parent_item_colon' => ''
		);
	 
		$args = array(
			'labels' => $labels,
			'public' => true,
			'publicly_queryable' => true,
			'show_in_menu ' => true,
			'menu_position' => 25,
			'exclude_from_search' => true,
			'show_ui' => true,
			'query_var' => true,
			'menu_icon' => WP_PLUGIN_URL . '/chimppress/img/mail.png',
			'map_meta_cap' => true,
			'rewrite' => true,
			'capability_type' => 'post',
			'hierarchical' => false,
			'can_export' => true,
			'show_in_nav_menus' => false,
			'supports' => array('title')
		  ); 
	 
		register_post_type( 'chimppress' , $args );
		flush_rewrite_rules();
	} //function
	
	function chimppress_columns_content($columns){ //displays the columns headings
		$columns = array(
			"cb" => "<input type=\"checkbox\" />",
			"title" => "Campaign Name",
			"status" => "Status",
			"sendtime" => "Send Time",
			"emailssent" => "Emails Sent"
		);
		return $columns;
	} //function
	 
	function chimppress_columns($column){ //content of columns

	    global $post;

	    $chimppress_mailchimp_api_functions = new chimppress_mailchimp_api_functions;

	    $mailchimp_id = get_post_meta($post->ID, 'mailchimp_id', true);

		$filters['campaign_id'] = $mailchimp_id;

		$campaign = $chimppress_mailchimp_api_functions->get_campaigns($filters);
		
        $status = $campaign['data'][0]['status'];
        
        $sendtime = $campaign['data'][0]['send_time'];
        
        $emailssent = $campaign['data'][0]['emails_sent'];

		switch ($column) {
	        case 'status':	    
	            echo $status;
	       		break;
	       	case 'sendtime':
	       		echo $sendtime;
	       		break;
	       	case 'emailssent':
	       		echo $emailssent;
	       		break;
	    }

	} //function
	
	function chimppress_enqueue_scripts() {
		global $post_type;
		if($_GET['post_type'] == 'chimppress' || ($post_type == 'chimppress')){
	    	//jquery
	        wp_enqueue_script( 'jquery' );
	        //jquery ui
	        wp_enqueue_script( 'jquery-ui-core' );
	        //jquery ui sortable
	        wp_enqueue_script( 'jquery-ui-sortable' );
	        //jquery ui draggable
	        wp_enqueue_script( 'jquery-ui-draggable' );
	        //jquery ui droppable
	        wp_enqueue_script( 'jquery-ui-droppable' );
	        //media upload
	        wp_enqueue_script('media-upload');
	        //jquery ui thickbox
	        wp_enqueue_script( 'thickbox' );
	        // chimppress js
	        wp_register_script( 'chimppress-editor', CP_url . '/js/editor.js');
	        wp_enqueue_script( 'chimppress-editor' );
	        //nicEdit
	        wp_register_script( 'nicEdit', CP_url . '/js/nicEdit.js');
	        wp_enqueue_script( 'nicEdit' );
	        // scripts for meta boxes
			wp_enqueue_script('common');
			wp_enqueue_script('wp-lists');
			wp_enqueue_script('postbox');   
	        //farbtastic
	        wp_register_script( 'farbtastic', CP_url . '/js/farbtastic.js');
	        wp_enqueue_script( 'farbtastic' );
	        //slider
	        wp_enqueue_script('jquery-depend-class', CP_url.'/js/jquery.dependClass.js', '', 1.0 );
	        wp_register_script( 'slider', CP_url . '/js/jquery.slider-min.js');
	        wp_enqueue_script( 'slider' );	       
 	
        }	                      
        
	} //function
	
	function chimppress_enqueue_styles(){
		global $wp_styles;
		wp_enqueue_style('chimppress_editor', CP_url.'/css/editor.css');
		//farbtastic
		wp_enqueue_style('farbtastic', CP_url.'/css/farbtastic.css');
		//thickbox
		wp_enqueue_style('thickbox');
		//slider
		wp_enqueue_style('jslider-style', CP_url.'/js/slider-styles/jslider.css');
		wp_enqueue_style('jslider-style-round', CP_url.'/js/slider-styles/jslider.round.plastic.css');
		
		wp_register_style('jslider-style-plastic-ie6', CP_url.'/js/slider-styles/jslider.round.plastic.ie6.css');
		wp_register_style('jslider-style-ie6', CP_url.'/js/slider-styles/jslider.round.plastic.ie6.css');
		$wp_styles->add_data('jslider-style-plastic-ie6', 'conditional', 'IE');
		$wp_styles->add_data('jslider-style-ie6', 'conditional', 'IE');		
		
	} //function	
	
	function add_menus(){
		add_submenu_page( 'edit.php?post_type=chimppress', 'Subscribers', 'Subscribers', 'manage_options', 'chimppress-subscribers', array(&$this, 'subscribers_page')); 
		add_submenu_page( 'edit.php?post_type=chimppress', 'ChimpPress Settings', 'Settings', 'manage_options', 'chimppress-settings', array(&$this, 'settings_page')); 
		add_submenu_page( 'edit.php?post_type=chimppress', 'Feedback', 'Feedback', 'manage_options', 'chimppress-feedback', array(&$this, 'feedback_page')); 
	} //function	
	
	function settings_page(){
		$chimppress_settings_page = new chimppress_settings_page;
		$chimppress_settings_page->settings_page();
	} //function	
	
	function subscribers_page(){
		$chimppress_subscribers_page = new chimppress_subscribers_page;
		$chimppress_subscribers_page->subscribers_page();
	} //function
	
	function feedback_page(){
		$chimppress_feedback_page = new chimppress_feedback_page;
		$chimppress_feedback_page->feedback_page();
	} //function	

} // class

?>