<?php

$chimppress_mailchimp_api_functions = new chimppress_mailchimp_api_functions;

class chimppress_mailchimp_api_functions {

	var $mailchimp_api;

	function chimppress_mailchimp_api_functions(){
		$this->__construct();
	} // function

	function __construct(){
		
		//add actions

		//add filters 
		
		$this->mailchimp_api = new MCAPI(get_option('chimppress_api_key'));
	
	} // function 

	function get_campaigns($filters=""){
		
		return $this->mailchimp_api->campaigns($filters);

	} // function
	
	function get_lists(){
	
		return $this->mailchimp_api->lists();		
	
	} //function
	
	function create_campaign($type, $opts, $content){
	
		$campaign_id = $this->mailchimp_api->campaignCreate($type, $opts, $content);
		
		if ($this->mailchimp_api->errorCode){
			update_option( 'CP_ERROR', $this->mailchimp_api->errorMessage );
			return 'ERROR ' . $this->mailchimp_api->errorMessage;
		} else {
			return $campaign_id;
		}
	
	} // function
	
	function update_campaign($id, $opts, $content){
		
		foreach($opts as $key => $value){
	
			$campaign_update = $this->mailchimp_api->campaignUpdate($id, $key, $value);
		
			if ($this->mailchimp_api->errorCode){
				update_option( 'CP_ERROR', $this->mailchimp_api->errorMessage );
				return 'ERROR ' . $this->mailchimp_api->errorMessage;
			}
			
		}
				
		$campaign_update = $this->mailchimp_api->campaignUpdate($id, 'content', $content);
	
		if ($this->mailchimp_api->errorCode){
			update_option( 'CP_ERROR', $this->mailchimp_api->errorMessage );
			return 'ERROR ' . $this->mailchimp_api->errorMessage;
		} else {
			return $campaign_update;
		}
	
	} // function
	
	function send_campaign($id){
	
		$this->mailchimp_api->campaignSendNow($id);
		
		if ($this->mailchimp_api->errorCode){
			update_option( 'CP_ERROR', $this->mailchimp_api->errorMessage );
			return 'ERROR ' . $this->mailchimp_api->errorMessage;
		} else {
			return true;
		}
	
	} // function
	
	function list_members($list){
	
		return $this->mailchimp_api->listMembers($list);
	
	}
	
	function list_member_info($list, $email){
	
		return $this->mailchimp_api->listMemberInfo($list, $email);
	
	} // function
	
	function list_update_member($list, $id, $merge_vars){
	
		$this->mailchimp_api->listUpdateMember($list, $id, $merge_vars);
				
		if ($this->mailchimp_api->errorCode){
			return '<div id="message" class="error below-h2">' . $this->mailchimp_api->errorMessage . '</div>';
		} else {
			return '<div id="message" class="updated below-h2">Subscriber updated!</div>';
		}
	
	} // function
	
	function list_subscribe($list, $id, $merge_vars){
	
		$this->mailchimp_api->listSubscribe( $list, $id, $merge_vars );
		
		if ($this->mailchimp_api->errorCode){
			return '<div id="message" class="error below-h2">' . $this->mailchimp_api->errorMessage . '</div>';
		} else {
			return'<div id="message" class="updated below-h2">The subscriber has been sent a confirmation email!<br/>Once they have confirmed they will show up in your subscriber list!</div>';
		}
	
	} // function
	
	function list_unsubscribe($list, $id){
	
		return $this->mailchimp_api->listUnsubscribe($list, $id, '', FALSE);
	
	}
	
}

?>